%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_PSet_Modify_Bush(PSet_ID, Pset_Name, Ori_Coord_ID, K1, K2, K3, K4, K5, K6, Elm_list)

% Принадлежность property set с номером PSet_ID к типу PBUSH должна проверяться вне данной функции до ее вызова

global ErrCode;

global DB_PSETS;
global DB_FIELDS;
global AST_PSETS;
global AST_COORD;

global AT_COORD;
global AT_PSETS;
global AT_FIELDS;

Elm_list = unique(Elm_list);
if (isempty(Elm_list))
    Elm_list = [];
end

% Проверка существования в базе property set
if (~DB_PSet_Exist(PSet_ID))
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: property set с номером %i отсутствует в базе !\n', PSet_ID);
    ErrCode = -1;
    return;
end

% Проверка имени property set
if (isempty(Pset_Name))
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: задано пустое имя property set !\n');
    ErrCode = -1;
    return;
end

% Проверка существования в базе системы координат
if (~isempty(Ori_Coord_ID))
    if (Ori_Coord_ID ~= 0)
        if (~DB_Coord_Exist(Ori_Coord_ID))
            fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: система координат с номером %i отсутствует в базе !\n', Ori_Coord_ID);
            ErrCode = -1;
            return;
        end
    end
end

% Защита от повреждения поля ориентации
if (~isempty(Ori_Coord_ID))
    if (size(Ori_Coord_ID,1) ~= 1)
        fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимая размерность величины Ori_Coord_ID !\n');
        ErrCode = -1;
        return;
    end
end

% Проверка значений
if (K1 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K1 [%e] !\n', K1);
    ErrCode = -1;
    return;
end

if (K2 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K2 [%e] !\n', K2);
    ErrCode = -1;
    return;
end

if (K3 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K3 [%e] !\n', K3);
    ErrCode = -1;
    return;
end

if (K4 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K4 [%e] !\n', K4);
    ErrCode = -1;
    return;
end

if (K5 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K5 [%e] !\n', K5);
    ErrCode = -1;
    return;
end

if (K6 < 0)
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: недопустимое значение переменной K6 [%e] !\n', K6);
    ErrCode = -1;
    return;
end

% Проверка поля
if (DB_Field_Isempty(DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID))
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: с property set %i ассоциировано пустое поле ориентации %i !\n', PSet_ID, DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID);
    fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
    ErrCode = -1;
    return;
end

if (~DB_Field_Isconstant(DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID))
    fprintf (1, '\nОшибка функции DB_PSet_Modify_Bush: с property set %i ассоциировано нетривиальное поле ориентации %i !\n', PSet_ID, DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID);
    fprintf (1, 'Нетривиальные поля ориентации в property set типа PBUSH не поддерживаются в текущей версии программы.\n');
    fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
    ErrCode = -1;
    return;
end

% Задание значений по умолчанию
if (isempty(Ori_Coord_ID))
    Ori_Coord_ID = 0;
end

if (isempty(K1))
    K1 = 0;
end

if (isempty(K2))
    K2 = 0;
end

if (isempty(K3))
    K3 = 0;
end

if (isempty(K4))
    K4 = 0;
end

if (isempty(K5))
    K5 = 0;
end

if (isempty(K6))
    K6 = 0;
end

% Изменение записи в базе
DB_PSETS{AT_PSETS(PSet_ID)}.Patran_name = Pset_Name;
DB_PSETS{AT_PSETS(PSet_ID)}.K(1) = K1;
DB_PSETS{AT_PSETS(PSet_ID)}.K(2) = K2;
DB_PSETS{AT_PSETS(PSet_ID)}.K(3) = K3;
DB_PSETS{AT_PSETS(PSet_ID)}.K(4) = K4;
DB_PSETS{AT_PSETS(PSet_ID)}.K(5) = K5;
DB_PSETS{AT_PSETS(PSet_ID)}.K(6) = K6;

% Внесение изменений в таблицу ассоциативности систем координат и в поле ориентации
Current_CID = DB_Field_Get_Default_Value(DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID);

if (Ori_Coord_ID ~= Current_CID)
    
    if (Current_CID > 0)
        AST_COORD{AT_COORD(Current_CID)}.PSet_list = setdiff(AST_COORD{AT_COORD(Current_CID)}.PSet_list, PSet_ID);
        if (isempty(AST_COORD{AT_COORD(Current_CID)}.PSet_list))
            AST_COORD{AT_COORD(Current_CID)}.PSet_list = [];
        end
    end
    
    if (Ori_Coord_ID > 0)
        AST_COORD{AT_COORD(Ori_Coord_ID)}.PSet_list = Union_Column(AST_COORD{AT_COORD(Ori_Coord_ID)}.PSet_list, PSet_ID);
    end
    
    DB_FIELDS{AT_FIELDS(DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID)}.Default = Ori_Coord_ID;
    DB_FIELDS{AT_FIELDS(DB_PSETS{AT_PSETS(PSet_ID)}.Ori_CID_Field_ID)}.Value_data{1,1} = Ori_Coord_ID;
    
end

% Списки добавления и удаления элементов
Add_Elm_list = setdiff(Elm_list, AST_PSETS{AT_PSETS(PSet_ID)}.Elm_list);
Remove_Elm_list = setdiff(AST_PSETS{AT_PSETS(PSet_ID)}.Elm_list, Elm_list);

% Изменение ассоциации элементов
if (~isempty(Remove_Elm_list))
    DB_Elm_Modify_Pset(Remove_Elm_list, []);
end

if (~isempty(Add_Elm_list))
    DB_Elm_Modify_Pset(Add_Elm_list, PSet_ID);
end
